#include "defs.h"
#include "point.h"

wxXmlNode* group_info::get_node() {
	wxXmlNode* ret = new wxXmlNode(nullptr, wxXML_ELEMENT_NODE, "g");
	ret->AddAttribute("id", this->name);
	return ret;
}

wxXmlNode* bkgd_item::get_node(double startingy, double length) {
	wxXmlNode* ret = new wxXmlNode(nullptr, wxXML_ELEMENT_NODE, "path");
	ret->AddAttribute("id", this->name);
	ret->AddAttribute("style", wxString::Format("fill:%s;stroke-width:0", this->rgb.GetAsString(wxC2S_HTML_SYNTAX)));
	ret->AddAttribute("d", wxString::Format("M %f %f L %f %f L %f %f L %f %f z", 
						this->start_left, startingy, this->end_left, startingy-length, 
						this->end_right, startingy-length, this->start_right, startingy));
	return ret;
}

wxXmlNode* frgd_item::get_node(double startingy, double length) {
	wxXmlNode* ret = new wxXmlNode(nullptr, wxXML_ELEMENT_NODE, "path");
	ret->AddAttribute("id", this->name);
	ret->AddAttribute("style", wxString::Format("fill:%s;stroke-width:0", this->rgb.GetAsString(wxC2S_HTML_SYNTAX)));

	wxString output;
	point pt{ this->start_left, startingy };
	point pend{ this->end_left, startingy-length };
	double angle = point::angle(pt, pend);
	pt.push_off(this->per_start, angle);
	double distance = point::distance(pt, pend);
	double travelled = 0.0;

	while (is_less(travelled, distance)) {
		point pt1;
		point pt2;
		point pt3;
		point pt4;
		pt1 = pt;
		pt2 = pt1;
		pt2.offset(this->width, angle);
		pt3 = pt1;
		pt3.push_off(this->per_on, angle);
		pt4 = pt3;
		pt4.offset(this->width, angle);
		travelled += this->per_on;
		if (is_less(pt3.y, startingy-length))
			pt3.y = startingy-length;
		if (is_less(pt4.y, startingy-length))
			pt4.y = startingy-length;
		output += wxString::Format("M %f %f L %f %f L %f %f L %f %f z ",
			pt1.x, pt1.y, pt2.x, pt2.y, pt4.x, pt4.y, pt3.x, pt3.y);
		pt = pt3;
		pt.push_off(this->per_off, angle);
		travelled += this->per_off;
	}
	
	ret->AddAttribute("d", output);
	return ret;
}
